//+------------------------------------------------------------------+
//|                                             Phoenix_5_6_04.mq4   |
//|                                       Copyright  2006, Hendrick |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Hendrick."

#define MAGICMA_A  20050610
#define MAGICMA_B  20060611

#define MAGICMA01  20050612
#define MAGICMA02  20060613
#define MAGICMA03  20060614

//+--------------------------------------------------------------------------------------------------+
//|  Fields that start with U_ - are USER fields - that the user always chooses.
//|                            - contain defaults that are the same for all currencies.
//|                            - You must set these, even if you set PrefSettings to True
//|
//|                         P  - If you set PrefSettings to False then you need to set all the
//|                              external fields  starting with P_ and U_ to your own settings.
//|
//|                         C  - These are just comments
//+--------------------------------------------------------------------------------------------------+

extern string     C_INIT                     = "=== Use INIT section - ignore all P_ settings =====";
extern bool       U_PrefSettings             = true;

extern string     C_PhoenixSettings          = "===== Phoenix Mode Selected ==============================";
extern int        U_PhoenixModeSelected      = 3;

extern string     C_FYI                      = "Set Mode Settings for the mode selected above.";

extern string     C_Mode1                    = "==== Phoenix Mode 1 (Classic - One Trade) ================";
extern int        U_Mode1_BreakEvenAfterPips = 0;

extern string     C_Mode12_Settings          = "==== Phoenix Mode 1 & 2 - shared fields ==================";
extern int        P_Mode12_TakeProfit        = 0;
extern int        P_Mode12_StopLoss          = 0;
extern int        P_Mode12_TrailingStop      = 0;

extern string     C_Mode2                    = "==== Phoenix Mode 2 (Classic-Plus second trade later) ====";
extern int        P_Mode2_TakeProfit_T2      = 0;
extern int        P_Mode2_StopLoss_T2        = 0;
extern int        P_Mode2_OpenTrade_2        = 0;     // Open Trade 2 after a protfit of this many pips
extern bool       U_Mode2_CloseTrade_1       = false; // If True the first trade closes when the second opens

extern string     C_Mode3                    = "==== Phoenix Mode 3 (Three trades at once) ===============";
extern int        P_Mode3_TakeProfit         = 0;
extern int        P_Mode3_StopLoss           = 0;
extern int        P_Mode3_CloseTrade2_3      = 0;




// X Close the Trades after X hours no matter what

extern string     C_Function_X               = "====== Ensure your trades close with x hours ======";
extern int        U_CloseAfter_x_Hours       = 0;

// Y Monday Management Settings

extern string     C_Function_Y               = "====== U_MoneyManagement decreases lotsize in a losing streak =====";
extern bool       U_MoneyManagement          = true; // auto decrease lotsize if > 1 losses in a row.
extern double     U_Lots                     = 1;
extern double     U_MaximumRisk              = 0.05;
extern int        U_DecreaseFactor           = 0;    // Must be greater that zero to run the decrease.
extern bool       U_AccountIsMicro           = false;

// Z Signal Settings

extern string     C_Signal1                  = "====== Signal 1 ===================================";
extern bool       U_UseSignal1               = true;
extern double     P_Percent                  = 0;
extern int        P_EnvelopePeriod           = 0;

extern string     C_Signal2                  = "====== Signal 2 ==================================";
extern bool       U_UseSignal2               = true;
extern int        P_SMAPeriod                = 0;
extern int        P_SMA2Bars                 = 0;

extern string     C_Signal3                  = "====== Signal 3 ==================================";
extern bool       U_UseSignal3               = true;
extern int        P_OSMAFast                 = 0;
extern int        P_OSMASlow                 = 0;
extern double     P_OSMASignal               = 0;

extern string     C_Signal4                  = "====== Signal 4 ==================================";
extern bool       U_UseSignal4               = true;
extern int        P_Fast_Period              = 0;
extern int        P_Fast_Price               = PRICE_OPEN;
extern int        P_Slow_Period              = 0;
extern int        P_Slow_Price               = PRICE_OPEN;
extern double     P_DVBuySell                = 0;
extern double     P_DVStayOut                = 0;

extern string     C_Signal5                  = "====== Signal 5 =================================";
extern bool       U_UseSignal5               = true;
extern int        U_TradeFrom1               = 0;
extern int        U_TradeUntil1              = 24;
extern int        U_TradeFrom2               = 0;
extern int        U_TradeUntil2              = 0;
extern int        U_TradeFrom3               = 0;
extern int        U_TradeUntil3              = 0;
extern int        U_TradeFrom4               = 0;
extern int        U_TradeUntil4              = 0;



int init()
{

//+------------------------------------------------------------------+
//| START Preffered Settings                                         |
//+------------------------------------------------------------------+

if(U_PrefSettings == true)
{
   if((Symbol() == "USDJPY") || (Symbol() == "USDJPYm"))
      {     
  
      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;
      P_Mode12_TrailingStop  = 0;

      P_Mode2_TakeProfit_T2  = 50;
      P_Mode2_StopLoss_T2    = 60;
      P_Mode2_OpenTrade_2    = 0;
      

      P_Mode3_TakeProfit     = 100;
      P_Mode3_StopLoss       = 55;
      P_Mode3_CloseTrade2_3  = 30;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0032;
      P_EnvelopePeriod       = 2;

      P_SMAPeriod            = 2;
      P_SMA2Bars             = 18;

      P_OSMAFast             = 5;
      P_OSMASlow             = 22;
      P_OSMASignal           = 2;
      
      P_Fast_Period          = 25;
      P_Slow_Period          = 15;
      P_DVBuySell            = 0.0029;
      P_DVStayOut            = 0.024;
      }

   if((Symbol() == "EURJPY") || (Symbol() == "EURJPYm"))
      {

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;
      P_Mode12_TrailingStop  = 0;
      
      P_Mode2_TakeProfit_T2  = 70;
      P_Mode2_StopLoss_T2    = 30;
      P_Mode2_OpenTrade_2    = 18;
      

      P_Mode3_TakeProfit     = 70;
      P_Mode3_StopLoss       = 80;      
      P_Mode3_CloseTrade2_3  = 55;

      // Signal 1 to 4 Settings

      P_Percent              = 0.007;
      P_EnvelopePeriod       = 2;
      
      P_SMAPeriod            = 4;
      P_SMA2Bars             = 16;

      P_OSMAFast             = 11;
      P_OSMASlow             = 20;
      P_OSMASignal           = 14;
      
      P_Fast_Period          = 20;
      P_Slow_Period          = 10;
      P_DVBuySell            = 0.0078;
      P_DVStayOut            = 0.026;
      }

   if((Symbol() == "GBPJPY") || (Symbol() == "GBPJPYm"))
      {

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;
      P_Mode12_TrailingStop  = 0;
      
      P_Mode2_TakeProfit_T2  = 130;
      P_Mode2_StopLoss_T2    = 80;
      P_Mode2_OpenTrade_2    = 2;
      

      P_Mode3_TakeProfit     = 90;
      P_Mode3_StopLoss       = 80;      
      P_Mode3_CloseTrade2_3  = 40;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0072;
      P_EnvelopePeriod       = 2;
      
      P_SMAPeriod            = 8;
      P_SMA2Bars             = 12;

      P_OSMAFast             = 5;
      P_OSMASlow             = 36;
      P_OSMASignal           = 10;

      P_Fast_Period          = 17;
      P_Slow_Period          = 28;
      P_DVBuySell            = 0.0034;
      P_DVStayOut            = 0.063;
      }
      
   if((Symbol() == "USDCHF") || (Symbol() == "USDCHFm"))
      {

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;
      P_Mode12_TrailingStop  = 0;
      
      P_Mode2_TakeProfit_T2  = 90;
      P_Mode2_StopLoss_T2    = 65;
      P_Mode2_OpenTrade_2    = 10;
      

      P_Mode3_TakeProfit     = 130;
      P_Mode3_StopLoss       = 80;      
      P_Mode3_CloseTrade2_3  = 85;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0056;
      P_EnvelopePeriod       = 10;
      
      P_SMAPeriod            = 5;
      P_SMA2Bars             = 9;

      P_OSMAFast             = 5;
      P_OSMASlow             = 12;
      P_OSMASignal           = 11;
      
      P_Fast_Period          = 5;
      P_Slow_Period          = 20;
      P_DVBuySell            = 0.00022;
      P_DVStayOut            = 0.0015;
      }
      
   if((Symbol() == "GBPUSD") || (Symbol() == "GBPUSDm"))
      {

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;
      P_Mode12_TrailingStop  = 0;
      
      P_Mode2_TakeProfit_T2  = 95;
      P_Mode2_StopLoss_T2    = 90;
      P_Mode2_OpenTrade_2    = 5;
      

      P_Mode3_TakeProfit     = 110;
      P_Mode3_StopLoss       = 80;      
      P_Mode3_CloseTrade2_3  = 90;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0023;
      P_EnvelopePeriod       = 6;
      
      P_SMAPeriod            = 3;
      P_SMA2Bars             = 14;

      P_OSMAFast             = 23;
      P_OSMASlow             = 17;
      P_OSMASignal           = 15;
      
      P_Fast_Period          = 25;
      P_Slow_Period          = 37;
      P_DVBuySell            = 0.00042;
      P_DVStayOut            = 0.05;
      }      
}
return(0);
}

//+------------------------------------------------------------------+
//| END Preffered Settings                                           |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| START EA  -  MainlIne                                            |
//+------------------------------------------------------------------+

void start()
   {
   if(Bars<100)
      {
      Print("bars less than 100");
      return(0);  
      }

   if(U_PhoenixModeSelected==1)//Phoenix Classic - Open One Trade
      {
      S1_Mode_1_2_OpenTrade_If_Signal();
      if(U_CloseAfter_x_Hours != 0)        X_Close_After_x_Hours();
      if(!P_Mode12_StopLoss==0)            M1_A_UpdateTStop_if_Applicable();
      if(U_Mode1_BreakEvenAfterPips != 0)  M1_B_UpdateTStop_if_BreakEven();
      }
      
         
   if(U_PhoenixModeSelected==2)//Phoenix - Open Second Trade after First Trade Profit
      {
      S1_Mode_1_2_OpenTrade_If_Signal();     
      if(U_CloseAfter_x_Hours != 0)        X_Close_After_x_Hours();
      M2_A_MakeSecondTrade_If_Profit();
      }

   if(U_PhoenixModeSelected==3)//Phoenix 123 - Open three trades at once
      {
      M3_A_Mode3_OpenTrade_If_Signal();
      M3_B_MoveSL_Trade_2_3_to_CurPr();
      M3_C_MoveSL_Trade_3_to_CalcPr();
      if(P_Mode3_CloseTrade2_3 != 0)       M3_D_CloseTrade23_If_Trd1_Loss();
      }
      
   } 
     
//+------------------------------------------------------------------+
//| END EA   - End Mainline                                          |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-------------  MODE 1 Functions ----------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function UpdateTStop_if_Applicable   - Mode 1              |
//+------------------------------------------------------------------+
void M1_A_UpdateTStop_if_Applicable()
{
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;
   
      if(OrderType() == OP_BUY)
         {
         if(((Bid - OrderOpenPrice()) > (Point * P_Mode12_TrailingStop)) && (OrderStopLoss() < (Bid - Point * P_Mode12_TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Bid - Point * P_Mode12_TrailingStop,
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }
      
      if(OrderType() == OP_SELL)
         {
         if(((OrderOpenPrice() - Ask) > (Point * P_Mode12_TrailingStop)) && (OrderStopLoss() > (Ask + Point * P_Mode12_TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Ask + Point * P_Mode12_TrailingStop,
                        OrderTakeProfit(),
                        0,
                        Red);
         }            
      }
}
//+------------------------------------------------------------------+
//| END Function UpdateTStop_if_Applicable   - Mode 1                |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function UpdateTStop_if_BreakEven  - Mode 1                |
//+------------------------------------------------------------------+

void M1_B_UpdateTStop_if_BreakEven()
{
for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;
   
      if(OrderType() == OP_BUY)
         {
         if((Bid-OrderOpenPrice()) > (Point*U_Mode1_BreakEvenAfterPips))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        OrderOpenPrice(),
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }

      if(OrderType() == OP_SELL)
         {
         if((OrderOpenPrice()-Ask) > (Point*U_Mode1_BreakEvenAfterPips))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        OrderOpenPrice(),
                        OrderTakeProfit(),
                        0,
                        Red);
         }            
      }
}

//+------------------------------------------------------------------+
//| END Function UpdateTStop_if_BreakEven   - Mode 1                 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+-------------  MODE 2 Functions ----------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function MakeSecondTrade_If_Profit  - Mode 2               |
//+------------------------------------------------------------------+

void M2_A_MakeSecondTrade_If_Profit()
{
int err = 0, total = OrdersTotal();

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol())       continue;

   if(OrderMagicNumber() == MAGICMA_B) break;

   if(OrderMagicNumber() != MAGICMA_A) continue;

   if(OrderType() == OP_BUY && (Bid-OrderOpenPrice() > Point*P_Mode2_OpenTrade_2))
      {
      if(OrderSend(Symbol(),OP_BUY,Y_MM_OptimizeLotSize(),Ask,3,Ask - P_Mode2_StopLoss_T2 * Point,Ask + P_Mode2_TakeProfit_T2 * Point,"P_Mode2_SecondTrade",MAGICMA_B,0,Blue) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(U_Mode2_CloseTrade_1==true) {M2_A_1_CloseFirstTrade();}
      return(0);
      }

   if(OrderType() == OP_SELL && (OrderOpenPrice()-Ask > Point*P_Mode2_OpenTrade_2))
      {
      if(OrderSend(Symbol(),OP_SELL,Y_MM_OptimizeLotSize(),Bid,3,Bid + P_Mode2_StopLoss_T2 * Point,Bid - P_Mode2_TakeProfit_T2*Point,"P_Mode2_SecondTrade",MAGICMA_B,0,Red) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(U_Mode2_CloseTrade_1==true) {M2_A_1_CloseFirstTrade();}
      return(0);
      }
   }

}
//+------------------------------------------------------------------+
//| END   Function MakeSecondTrade_If_Profit  - Mode 2               |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Close First Trade - Mode 2                        |
//+------------------------------------------------------------------+

int M2_A_1_CloseFirstTrade()
{
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;
      
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
         return(0); 
      }
}  
//+------------------------------------------------------------------+
//| END Function Close First Trade - Mode 2                          |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-------------  MODE 3 Functions ----------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Open Trade If Signal   -  MODE 3                  |
//+------------------------------------------------------------------+
int M3_A_Mode3_OpenTrade_If_Signal()
{

int Signal = 0, err = 0, total = OrdersTotal(), decimalPlaces=1;
if(U_AccountIsMicro==true) decimalPlaces=2;
double lots123 = NormalizeDouble(Y_MM_OptimizeLotSize()/3,decimalPlaces);

if(lots123 < 0.1 && U_AccountIsMicro==false) {lots123=0.1;}
if(lots123 < 0.01 && U_AccountIsMicro==true) {lots123=0.01;}

if(M3_A_1_NumberOfOpenPositions(Symbol()) < 1)
   {
   if(Z_CheckSignals(Signal)==1)
      {
      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-NormalizeDouble(P_Mode3_TakeProfit/2,0)*Point,"P_Mode3_FirstTrade",MAGICMA01,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }

      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-P_Mode3_TakeProfit*Point,"P_Mode3_SecondTrade",MAGICMA02,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }

      if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-NormalizeDouble(P_Mode3_TakeProfit*1.5,0)*Point,"P_Mode3_ThirdTrade",MAGICMA03,0,Red)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }

   if(Z_CheckSignals(Signal)==2)
      {
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+NormalizeDouble(P_Mode3_TakeProfit/2,0)*Point,"P_Mode3_FirstTrade",MAGICMA01,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+P_Mode3_TakeProfit*Point,"P_Mode3_SecondTrade",MAGICMA02,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+NormalizeDouble(P_Mode3_TakeProfit*1.5,0)*Point,"P_Mode3_ThirdTrade",MAGICMA03,0,Blue)<0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
   }
}
//+------------------------------------------------------------------+
//| END   Function Open Trade If Signal   -  MODE 3                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Number of Open Posistinos - Mode 3                |
//+------------------------------------------------------------------+
int M3_A_1_NumberOfOpenPositions(string symbol)
  {
   int buys=0,sells=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(
      (OrderSymbol()==Symbol()) &&
      ((OrderMagicNumber()==MAGICMA01) ||
       (OrderMagicNumber()==MAGICMA02) ||
       (OrderMagicNumber()==MAGICMA03)))
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
    return(buys+sells);
  }
//+------------------------------------------------------------------+
//| END   Function Number of Open Posistinos - Mode 3                |
//+------------------------------------------------------------------+


//+-------------------------------------------------------------------+
//| START Move stoploss for trade 2 or 3 to the Current Price - Mode3 |
//+-------------------------------------------------------------------+

void M3_B_MoveSL_Trade_2_3_to_CurPr()
{

int err = 0, total = OrdersTotal(), history = HistoryTotal();
bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol())       continue;

   if(OrderMagicNumber() == MAGICMA03) break;

   if(OrderMagicNumber() == MAGICMA02) break;

   if(OrderMagicNumber() != MAGICMA01) continue;

   if(OrderProfit() > 0)
      {
      ChangeStopLoss=true;
      break;
      }
   }


  if(ChangeStopLoss==true)
   {
   for(int y = total - 1; y >= 0; y --)
      {
      if(!OrderSelect(y,SELECT_BY_POS))
         {
         err = GetLastError();
         Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
         continue;
         }

      if(OrderSymbol() != Symbol()) continue;

      if(OrderMagicNumber() == MAGICMA02 || OrderMagicNumber() == MAGICMA03)
         {
         if(OrderType()==OP_BUY)
            {
            if(OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,GreenYellow)<0)
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }
//         return(0);
         }

         if(OrderType()==OP_SELL)
         {
         if(OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,GreenYellow)<0)
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }
//         return(0);
         }
}
}
}
}
//}
//+------------------------------------------------------------------+
//| END  Move stoploss for trade 2 or 3 to the Current Price - Mode3 |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Move stoploss for trade 3 to a calculated Price - Mode3    |
//+------------------------------------------------------------------+

void M3_C_MoveSL_Trade_3_to_CalcPr()
{

double NewSLTrade3B,NewSLTrade3S;
int err = 0, total = OrdersTotal(), history = HistoryTotal();
bool ChangeStopLoss = false;

for(int z = history - 1; z >= 0; z --)
   {
   if(!OrderSelect( z,SELECT_BY_POS,MODE_HISTORY))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol())       continue;

   if(OrderMagicNumber() == MAGICMA03) break;

   if(OrderMagicNumber() == MAGICMA01) break;

   if(OrderMagicNumber() != MAGICMA02) continue;

   if(OrderProfit() > 0)
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect(y,SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }

         if(OrderSymbol() != Symbol()) continue;

         if(OrderMagicNumber() == MAGICMA03)
            {
            if(OrderType()==OP_BUY)
               {
               NewSLTrade3B=OrderOpenPrice()+NormalizeDouble(((OrderTakeProfit()-OrderOpenPrice())/2),Digits);
               if(OrderModify(OrderTicket(),OrderOpenPrice(),NewSLTrade3B,OrderTakeProfit(),0,GreenYellow)<0)
                  {
                  err = GetLastError();
                  Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
                  continue;
                  }
               return(0);
               }

            if(OrderType()==OP_SELL)
               {
               NewSLTrade3S=OrderOpenPrice()-NormalizeDouble(((OrderOpenPrice()-OrderTakeProfit())/2),Digits);
               if(OrderModify(OrderTicket(),OrderOpenPrice(),NewSLTrade3S,OrderTakeProfit(),0,GreenYellow)<0)
                  {
                  err = GetLastError();
                  Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
                  continue;
                  }
               return(0);
               }
}
}
}
}
}

//+------------------------------------------------------------------+
//| START Move stoploss for trade 3 to a calculated Price - Mode3    |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Close Trade 2 And 3 if Trade 1 is losing - Mode3  |
//+------------------------------------------------------------------+
void M3_D_CloseTrade23_If_Trd1_Loss()
{

int err = 0, total = OrdersTotal();
bool CloseTrade=false;

for(int z = total - 1; z >= 0; z --)
   {
   if(!OrderSelect( z, SELECT_BY_POS))
      {
      err = GetLastError();
      Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
      continue;
      }

   if(OrderSymbol() != Symbol())       continue;

   if(OrderMagicNumber() != MAGICMA01) continue;

   if(OrderType() == OP_BUY && (OrderOpenPrice()-Bid > Point * P_Mode3_CloseTrade2_3)) {CloseTrade=true;}
   if(OrderType() == OP_SELL && (Ask-OrderOpenPrice() > Point * P_Mode3_CloseTrade2_3)) {CloseTrade=true;}

   if(CloseTrade)
      {
      for(int y = total - 1; y >= 0; y --)
         {
         if(!OrderSelect( y, SELECT_BY_POS))
            {
            err = GetLastError();
            Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",err );
            continue;
            }
         if(OrderSymbol() != Symbol()) continue;

         if(OrderMagicNumber() == MAGICMA02 || OrderMagicNumber() == MAGICMA03)
            {
            if(OrderType() == OP_BUY)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet)<0)
                  {
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
               return(0);
               }
            if(OrderType() == OP_SELL)
               {
               if(OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet)<0)
                  {
                  err = GetLastError();
                  Print("Error Ordersend(",err,"): ");
                  return(-1);
                  }
              return(0);
               }
             }
}
}
}
}

//+------------------------------------------------------------------+
//| END   Function Close Trade 2 And 3 if Trade 1 is losing - Mode3  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-------------  Shared Functions for PHOENIX  ---------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Open Trade If Signal for Mode 1 or Mode 2         |
//+------------------------------------------------------------------+
int S1_Mode_1_2_OpenTrade_If_Signal()
{      
int Signal=0, err = 0, total = OrdersTotal();

if(S1_1_NumberOfOpenOrders(Symbol()) < 1)
   {  
   if(Z_CheckSignals(Signal)==1)      // If Sell Signal //
      {
      if(OrderSend(Symbol(),OP_SELL,Y_MM_OptimizeLotSize(),Bid,3,Bid+P_Mode12_StopLoss*Point,Bid-P_Mode12_TakeProfit*Point,"FirstTrade",MAGICMA_A,0,Red) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
       return(0);
      }
      
   if(Z_CheckSignals(Signal)==2)      // If Buy Signal //
      {
      if(OrderSend(Symbol(),OP_BUY,Y_MM_OptimizeLotSize(),Ask,3,Ask-P_Mode12_StopLoss*Point,Ask+P_Mode12_TakeProfit*Point,"FirstTrade",MAGICMA_A,0,Blue) < 0)
         {
         err = GetLastError();
         Print("Error Ordersend(",err,"): ");
         return(-1);
         }
      return(0);
      }
   }
}
//+------------------------------------------------------------------+
//| END   Function Open Trade If Signal for Mode 1 or Mode 2         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Number of Open Orders                             |
//+------------------------------------------------------------------+
int S1_1_NumberOfOpenOrders(string symbol)
  {
   int count=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && (OrderMagicNumber()==MAGICMA_A || OrderMagicNumber()==MAGICMA_B))
        {
         count++;
        }
     }
     return(count);
  }
//+------------------------------------------------------------------+
//| STOP Function Number of Open Orders                              |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-----  Functions for use in Any Expert Advisor  ------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Close Trade After x Hours                                  |
//+------------------------------------------------------------------+

void X_Close_After_x_Hours()
{
int total = OrdersTotal();

for(int cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if(OrderType()<=OP_SELL &&
      OrderSymbol()==Symbol() &&
      OrderMagicNumber()==MAGICMA_A)
      {            
         if((CurTime()-OrderOpenTime())>(U_CloseAfter_x_Hours*3600) && OrderProfit()<0)
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,10,Violet);
            }
      }
   }
}

//+------------------------------------------------------------------+
//| END Close Trade After x Hours                                    |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START MoneyManagement - Optimize lot size                        |
//+------------------------------------------------------------------+

double Y_MM_OptimizeLotSize()
  {
  if(U_MoneyManagement==false) return(U_Lots);
   double lot=U_Lots;
   int    orders=HistoryTotal();
   int    losses=0;
   int    decimalPlaces=1;
   
   if(U_AccountIsMicro==true) decimalPlaces=2;

   lot=NormalizeDouble(AccountFreeMargin()*U_MaximumRisk/1000.0,decimalPlaces);
   if(U_DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/U_DecreaseFactor,decimalPlaces);
     }

   if(lot<0.1 && U_AccountIsMicro==false) lot=0.1;
   if(lot<0.01 && U_AccountIsMicro==true) lot=0.01;
   if(lot>99) lot=99;
   return(lot);

  }
  
//+------------------------------------------------------------------+
//| SEND MoneyManagement - Optimize lot size                         |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Z Check Signals                                   |
//+------------------------------------------------------------------+

//=====================SIGNAL1========================

int Z_CheckSignals(int Signal)
{
Signal=0;

bool BuySignal1=false, SellSignal1=false;

double HighEnvelope1 = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_UPPER,1);
double LowEnvelope1  = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_LOWER,1);
double CloseBar1     = iClose(NULL,0,1);

if(U_UseSignal1)
{
   if(CloseBar1 > HighEnvelope1) {SellSignal1 = true;} 
   if(CloseBar1 < LowEnvelope1)  {BuySignal1  = true;}
}
else {SellSignal1=true;BuySignal1=true;}


//=====================SIGNAL2========================

bool BuySignal2=false, SellSignal2=false;

double SMA1=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
double SMA2=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,P_SMA2Bars);

if(U_UseSignal2)
{
   if(SMA2-SMA1>0) {BuySignal2  = true;}
   if(SMA2-SMA1<0) {SellSignal2 = true;}
}
else {SellSignal2=true;BuySignal2=true;}


//=====================SIGNAL3========================

bool BuySignal3=false, SellSignal3=false;

double OsMABar2=iOsMA(NULL,0,P_OSMASlow,P_OSMAFast,P_OSMASignal,PRICE_CLOSE,2);
double OsMABar1=iOsMA(NULL,0,P_OSMASlow,P_OSMAFast,P_OSMASignal,PRICE_CLOSE,1);

if(U_UseSignal3)
{
   if(OsMABar2 > OsMABar1)  {SellSignal3 = true;}
   if(OsMABar2 < OsMABar1)  {BuySignal3  = true;}
}
else {SellSignal3=true;BuySignal3=true;}


//=====================SIGNAL4========================  

   double diverge;
   bool BuySignal4=false,SellSignal4=false;
   
   diverge = Z_S4_divergence(P_Fast_Period, P_Slow_Period, P_Fast_Price, P_Slow_Price,0);

if(U_UseSignal4)
{
   if(diverge >= P_DVBuySell && diverge <= P_DVStayOut)
       {BuySignal4 = true;}
   if(diverge <= (P_DVBuySell*(-1)) && diverge >= (P_DVStayOut*(-1)))
       {SellSignal4 = true;} 
}       
else {SellSignal4=true;BuySignal4=true;}


//=====================SIGNAL5=======================  

bool BuySignal5=false, SellSignal5=false;

if(U_UseSignal5)
{
   int iHour=TimeHour(LocalTime());
   int ValidTradeTime = Z_S5_ValidTradeTime(iHour);
   if(ValidTradeTime==true)
    {
    BuySignal5=true;
    SellSignal5=true;
    }
}
else {SellSignal5=true;BuySignal5=true;}

if((SellSignal1==true) && (SellSignal2==true) && (SellSignal3==true) && (SellSignal4==true) && (SellSignal5==true)) return(1);  
if((BuySignal1==true) && (BuySignal2==true) && (BuySignal3==true) && (BuySignal4==true) && (BuySignal5==true)) return(2);
}

//+------------------------------------------------------------------+
//| END Function Z Check Signals                                     |
//+------------------------------------------------------------------+   


//+------------------------------------------------------------------+
//| START Signal 4 Function Diverge                                  |
//+------------------------------------------------------------------+

double Z_S4_divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
    int i;
    double maF1, maF2, maS1, maS2;

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);

    return(maF2-maS2);
  }

//+------------------------------------------------------------------+
//| END Signal 4 Function Diverge                                    |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Signal 5 Function Valid Trade Time                         |
//+------------------------------------------------------------------+

bool Z_S5_ValidTradeTime (int iHour)
   {
      if(((iHour >= U_TradeFrom1) && (iHour <= (U_TradeUntil1-1)))||((iHour>= U_TradeFrom2) && (iHour <= (U_TradeUntil2-1)))||((iHour >= U_TradeFrom3)&& (iHour <= (U_TradeUntil3-1)))||((iHour >= U_TradeFrom4) && (iHour <=(U_TradeUntil4-1))))
      {
       return (true);
      }
      else
       return (false);
   }  

//+------------------------------------------------------------------+
//| END Signal 5 Function Valid Trade Time                           |
//+------------------------------------------------------------------+